# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['AccountTokenArgs', 'AccountToken']

@pulumi.input_type
class AccountTokenArgs:
    def __init__(__self__, *,
                 account: Optional[pulumi.Input[str]] = None,
                 expires_in: Optional[pulumi.Input[str]] = None,
                 renew_after: Optional[pulumi.Input[str]] = None,
                 renew_before: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a AccountToken resource.
        :param pulumi.Input[str] account: Account name. Defaults to the current account. I.e. the account configured on the `provider` block.
        :param pulumi.Input[str] expires_in: Duration before the token will expire. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. E.g. `12h`, `7d`. Default: No expiration.
        :param pulumi.Input[str] renew_after: Duration to control token silent regeneration based on token age. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. If set, then the token will be regenerated if it is older than `renew_after`. I.e. if `currentDate - issued_at > renew_after`.
        :param pulumi.Input[str] renew_before: Duration to control token silent regeneration based on remaining token lifetime. If `expires_in` is set, Pulumi will regenerate the token if `expires_at - currentDate < renew_before`. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`.
        """
        if account is not None:
            pulumi.set(__self__, "account", account)
        if expires_in is not None:
            pulumi.set(__self__, "expires_in", expires_in)
        if renew_after is not None:
            pulumi.set(__self__, "renew_after", renew_after)
        if renew_before is not None:
            pulumi.set(__self__, "renew_before", renew_before)

    @property
    @pulumi.getter
    def account(self) -> Optional[pulumi.Input[str]]:
        """
        Account name. Defaults to the current account. I.e. the account configured on the `provider` block.
        """
        return pulumi.get(self, "account")

    @account.setter
    def account(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "account", value)

    @property
    @pulumi.getter(name="expiresIn")
    def expires_in(self) -> Optional[pulumi.Input[str]]:
        """
        Duration before the token will expire. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. E.g. `12h`, `7d`. Default: No expiration.
        """
        return pulumi.get(self, "expires_in")

    @expires_in.setter
    def expires_in(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "expires_in", value)

    @property
    @pulumi.getter(name="renewAfter")
    def renew_after(self) -> Optional[pulumi.Input[str]]:
        """
        Duration to control token silent regeneration based on token age. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. If set, then the token will be regenerated if it is older than `renew_after`. I.e. if `currentDate - issued_at > renew_after`.
        """
        return pulumi.get(self, "renew_after")

    @renew_after.setter
    def renew_after(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "renew_after", value)

    @property
    @pulumi.getter(name="renewBefore")
    def renew_before(self) -> Optional[pulumi.Input[str]]:
        """
        Duration to control token silent regeneration based on remaining token lifetime. If `expires_in` is set, Pulumi will regenerate the token if `expires_at - currentDate < renew_before`. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`.
        """
        return pulumi.get(self, "renew_before")

    @renew_before.setter
    def renew_before(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "renew_before", value)


@pulumi.input_type
class _AccountTokenState:
    def __init__(__self__, *,
                 account: Optional[pulumi.Input[str]] = None,
                 expires_at: Optional[pulumi.Input[str]] = None,
                 expires_in: Optional[pulumi.Input[str]] = None,
                 issued_at: Optional[pulumi.Input[str]] = None,
                 jwt: Optional[pulumi.Input[str]] = None,
                 renew_after: Optional[pulumi.Input[str]] = None,
                 renew_before: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering AccountToken resources.
        :param pulumi.Input[str] account: Account name. Defaults to the current account. I.e. the account configured on the `provider` block.
        :param pulumi.Input[str] expires_at: If `expires_in` is set, Unix timestamp upon which the token will expire.
        :param pulumi.Input[str] expires_in: Duration before the token will expire. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. E.g. `12h`, `7d`. Default: No expiration.
        :param pulumi.Input[str] issued_at: Unix timestamp at which the token was issued.
        :param pulumi.Input[str] jwt: The raw JWT.
        :param pulumi.Input[str] renew_after: Duration to control token silent regeneration based on token age. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. If set, then the token will be regenerated if it is older than `renew_after`. I.e. if `currentDate - issued_at > renew_after`.
        :param pulumi.Input[str] renew_before: Duration to control token silent regeneration based on remaining token lifetime. If `expires_in` is set, Pulumi will regenerate the token if `expires_at - currentDate < renew_before`. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`.
        """
        if account is not None:
            pulumi.set(__self__, "account", account)
        if expires_at is not None:
            pulumi.set(__self__, "expires_at", expires_at)
        if expires_in is not None:
            pulumi.set(__self__, "expires_in", expires_in)
        if issued_at is not None:
            pulumi.set(__self__, "issued_at", issued_at)
        if jwt is not None:
            pulumi.set(__self__, "jwt", jwt)
        if renew_after is not None:
            pulumi.set(__self__, "renew_after", renew_after)
        if renew_before is not None:
            pulumi.set(__self__, "renew_before", renew_before)

    @property
    @pulumi.getter
    def account(self) -> Optional[pulumi.Input[str]]:
        """
        Account name. Defaults to the current account. I.e. the account configured on the `provider` block.
        """
        return pulumi.get(self, "account")

    @account.setter
    def account(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "account", value)

    @property
    @pulumi.getter(name="expiresAt")
    def expires_at(self) -> Optional[pulumi.Input[str]]:
        """
        If `expires_in` is set, Unix timestamp upon which the token will expire.
        """
        return pulumi.get(self, "expires_at")

    @expires_at.setter
    def expires_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "expires_at", value)

    @property
    @pulumi.getter(name="expiresIn")
    def expires_in(self) -> Optional[pulumi.Input[str]]:
        """
        Duration before the token will expire. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. E.g. `12h`, `7d`. Default: No expiration.
        """
        return pulumi.get(self, "expires_in")

    @expires_in.setter
    def expires_in(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "expires_in", value)

    @property
    @pulumi.getter(name="issuedAt")
    def issued_at(self) -> Optional[pulumi.Input[str]]:
        """
        Unix timestamp at which the token was issued.
        """
        return pulumi.get(self, "issued_at")

    @issued_at.setter
    def issued_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "issued_at", value)

    @property
    @pulumi.getter
    def jwt(self) -> Optional[pulumi.Input[str]]:
        """
        The raw JWT.
        """
        return pulumi.get(self, "jwt")

    @jwt.setter
    def jwt(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "jwt", value)

    @property
    @pulumi.getter(name="renewAfter")
    def renew_after(self) -> Optional[pulumi.Input[str]]:
        """
        Duration to control token silent regeneration based on token age. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. If set, then the token will be regenerated if it is older than `renew_after`. I.e. if `currentDate - issued_at > renew_after`.
        """
        return pulumi.get(self, "renew_after")

    @renew_after.setter
    def renew_after(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "renew_after", value)

    @property
    @pulumi.getter(name="renewBefore")
    def renew_before(self) -> Optional[pulumi.Input[str]]:
        """
        Duration to control token silent regeneration based on remaining token lifetime. If `expires_in` is set, Pulumi will regenerate the token if `expires_at - currentDate < renew_before`. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`.
        """
        return pulumi.get(self, "renew_before")

    @renew_before.setter
    def renew_before(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "renew_before", value)


class AccountToken(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account: Optional[pulumi.Input[str]] = None,
                 expires_in: Optional[pulumi.Input[str]] = None,
                 renew_after: Optional[pulumi.Input[str]] = None,
                 renew_before: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages ArgoCD [account](https://argo-cd.readthedocs.io/en/latest/user-guide/commands/argocd_account/) JWT tokens.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_argocd as argocd

        # Token for account configured on the `provider`
        this = argocd.AccountToken("this", renew_after="168h")
        # Token for ac count `foo`
        foo = argocd.AccountToken("foo",
            account="foo",
            expires_in="168h",
            renew_before="84h")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] account: Account name. Defaults to the current account. I.e. the account configured on the `provider` block.
        :param pulumi.Input[str] expires_in: Duration before the token will expire. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. E.g. `12h`, `7d`. Default: No expiration.
        :param pulumi.Input[str] renew_after: Duration to control token silent regeneration based on token age. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. If set, then the token will be regenerated if it is older than `renew_after`. I.e. if `currentDate - issued_at > renew_after`.
        :param pulumi.Input[str] renew_before: Duration to control token silent regeneration based on remaining token lifetime. If `expires_in` is set, Pulumi will regenerate the token if `expires_at - currentDate < renew_before`. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[AccountTokenArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages ArgoCD [account](https://argo-cd.readthedocs.io/en/latest/user-guide/commands/argocd_account/) JWT tokens.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_argocd as argocd

        # Token for account configured on the `provider`
        this = argocd.AccountToken("this", renew_after="168h")
        # Token for ac count `foo`
        foo = argocd.AccountToken("foo",
            account="foo",
            expires_in="168h",
            renew_before="84h")
        ```

        :param str resource_name: The name of the resource.
        :param AccountTokenArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AccountTokenArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account: Optional[pulumi.Input[str]] = None,
                 expires_in: Optional[pulumi.Input[str]] = None,
                 renew_after: Optional[pulumi.Input[str]] = None,
                 renew_before: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AccountTokenArgs.__new__(AccountTokenArgs)

            __props__.__dict__["account"] = account
            __props__.__dict__["expires_in"] = expires_in
            __props__.__dict__["renew_after"] = renew_after
            __props__.__dict__["renew_before"] = renew_before
            __props__.__dict__["expires_at"] = None
            __props__.__dict__["issued_at"] = None
            __props__.__dict__["jwt"] = None
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["jwt"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(AccountToken, __self__).__init__(
            'argocd:index/accountToken:AccountToken',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            account: Optional[pulumi.Input[str]] = None,
            expires_at: Optional[pulumi.Input[str]] = None,
            expires_in: Optional[pulumi.Input[str]] = None,
            issued_at: Optional[pulumi.Input[str]] = None,
            jwt: Optional[pulumi.Input[str]] = None,
            renew_after: Optional[pulumi.Input[str]] = None,
            renew_before: Optional[pulumi.Input[str]] = None) -> 'AccountToken':
        """
        Get an existing AccountToken resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] account: Account name. Defaults to the current account. I.e. the account configured on the `provider` block.
        :param pulumi.Input[str] expires_at: If `expires_in` is set, Unix timestamp upon which the token will expire.
        :param pulumi.Input[str] expires_in: Duration before the token will expire. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. E.g. `12h`, `7d`. Default: No expiration.
        :param pulumi.Input[str] issued_at: Unix timestamp at which the token was issued.
        :param pulumi.Input[str] jwt: The raw JWT.
        :param pulumi.Input[str] renew_after: Duration to control token silent regeneration based on token age. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. If set, then the token will be regenerated if it is older than `renew_after`. I.e. if `currentDate - issued_at > renew_after`.
        :param pulumi.Input[str] renew_before: Duration to control token silent regeneration based on remaining token lifetime. If `expires_in` is set, Pulumi will regenerate the token if `expires_at - currentDate < renew_before`. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AccountTokenState.__new__(_AccountTokenState)

        __props__.__dict__["account"] = account
        __props__.__dict__["expires_at"] = expires_at
        __props__.__dict__["expires_in"] = expires_in
        __props__.__dict__["issued_at"] = issued_at
        __props__.__dict__["jwt"] = jwt
        __props__.__dict__["renew_after"] = renew_after
        __props__.__dict__["renew_before"] = renew_before
        return AccountToken(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def account(self) -> pulumi.Output[Optional[str]]:
        """
        Account name. Defaults to the current account. I.e. the account configured on the `provider` block.
        """
        return pulumi.get(self, "account")

    @property
    @pulumi.getter(name="expiresAt")
    def expires_at(self) -> pulumi.Output[str]:
        """
        If `expires_in` is set, Unix timestamp upon which the token will expire.
        """
        return pulumi.get(self, "expires_at")

    @property
    @pulumi.getter(name="expiresIn")
    def expires_in(self) -> pulumi.Output[Optional[str]]:
        """
        Duration before the token will expire. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. E.g. `12h`, `7d`. Default: No expiration.
        """
        return pulumi.get(self, "expires_in")

    @property
    @pulumi.getter(name="issuedAt")
    def issued_at(self) -> pulumi.Output[str]:
        """
        Unix timestamp at which the token was issued.
        """
        return pulumi.get(self, "issued_at")

    @property
    @pulumi.getter
    def jwt(self) -> pulumi.Output[str]:
        """
        The raw JWT.
        """
        return pulumi.get(self, "jwt")

    @property
    @pulumi.getter(name="renewAfter")
    def renew_after(self) -> pulumi.Output[Optional[str]]:
        """
        Duration to control token silent regeneration based on token age. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`. If set, then the token will be regenerated if it is older than `renew_after`. I.e. if `currentDate - issued_at > renew_after`.
        """
        return pulumi.get(self, "renew_after")

    @property
    @pulumi.getter(name="renewBefore")
    def renew_before(self) -> pulumi.Output[Optional[str]]:
        """
        Duration to control token silent regeneration based on remaining token lifetime. If `expires_in` is set, Pulumi will regenerate the token if `expires_at - currentDate < renew_before`. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`.
        """
        return pulumi.get(self, "renew_before")

